<?php
namespace PME\Controllers\Relatorios;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class NutrientesCardController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $birtStrategy;
    protected $utilities;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $utilities) {
        $this->entityManager = $entityManager;
        $this->birtStrategy = $birtStrategy;
        $this->utilities = $utilities;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'PME09100' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09101' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09102' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09103' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09104' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'CDNUTRIENTE1'  => 'P_CDNUTRIENTE1',
            'CDNUTRIENTE2'  => 'P_CDNUTRIENTE2',
            'CDNUTRIENTE3'  => 'P_CDNUTRIENTE3',
            'CDNUTRIENTE4'  => 'P_CDNUTRIENTE4',
            'CDFILIAL'      => 'P_CDFILIAGRE',
            'NRORG'         => 'P_NRORG',
            )
        ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $nrorg = $this->utilities->getNrOrg();
        $row['NRORG'] = $nrorg;
        
        if(empty($row['UNIDADE'])){
          $cdfilial = $row['CDFILCENTPME'];  
          $row['NMFILIAL'] = "";
          $row['CDFILIAL'] = "";
        } else{ 
            $cdfilial = $row['UNIDADE']['CDFILIAL'];
            $row['CDFILIAL'] = $cdfilial;
            $row['NMFILIAL'] = $row['UNIDADE']['NMFILIAL'];
        }
        
        //if(empty($row['CDNUTRIENTE'])) $row['CDNUTRIENTE'] = $this->getNutrientes($cdfilial);
        if(empty($row['CDNUTRIENTE'])) $listaNutri = 'T';
        else {
            $listaNutri = '';
            foreach($row['CDNUTRIENTE'] as $nutr) {
                $listaNutri .= $nutr['CDNUTRIENTE'].'_';
            }
        }
        
        $nrSeqNutr = $this->procedureCalcNutr($row, $cdfilial, $listaNutri);
        $row['NRSEQUNUTR'] = $nrSeqNutr;

        if(empty($row['CDTIPOPRAT'])) $row['LISTATPPRATO'] = 'T';
        else $row['LISTATPPRATO'] = join('_', $row['CDTIPOPRAT']);

        if(count($row['CDSERVFILI']) == 0) $row['CDSERVFILI'] = 'T';
        else $row['CDSERVFILI'] = is_array($row['CDSERVFILI']) ? join("_", $row['CDSERVFILI']) : $row['CDSERVFILI'];

        if($row['CD_REPORT_CODE'] == 'PME09104') $this->setParamNutrientes($row);
        
        $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
        $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }

    private function procedureCalcNutr($row, $cdfilial, $listaNutri){
      if(count($row['SERVICO']) == 0) $cdservfili = 'T';
      else $cdservfili = join('_', $row['SERVICO']);
      $nrSeqNutr = $this->utilities->callProcedureNutrCard($row['CDFILCENTPME'], $cdfilial, $cdservfili, $listaNutri,$row['IMPNDPCAL'], $row['PERIODODE'], $row['PERIODOATE'], $row['CDTIPOCARD']);

      return $nrSeqNutr;
    }

    private function getNutrientes ($cdfilial) {
        try {
            $sql = "SELECT CDNUTRIENTE || ' - ' || NMNUTRIENTE AS DESCRICAO, CDNUTRIENTE, NMNUTRIENTE, NRORG FROM NUTRIENTE";
            return $this->entityManager->getConnection()->fetchAll($sql, []);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function setParamNutrientes($row) {
        $nutrientes = $this->utilities->getNutrientes($row['CDFILCENTPME']);

        if(!empty($nutrientes)) {
            $row['CDNUTRIENTE1'] = $nutrientes[0]["CDNUTRIENTE1"];
            $row['CDNUTRIENTE2'] = $nutrientes[0]["CDNUTRIENTE2"]; 
            $row['CDNUTRIENTE3'] = $nutrientes[0]["CDNUTRIENTE3"];
            $row['CDNUTRIENTE4'] = $nutrientes[0]["CDNUTRIENTE4"];
        }else {
            $row['CDNUTRIENTE1'] = null;
            $row['CDNUTRIENTE2'] = null; 
            $row['CDNUTRIENTE3'] = null;
            $row['CDNUTRIENTE4'] = null;
        }
    }
}